;------------------------------------------------------------------------
;-  Written by: sanmaiwashi (admin@wazoku.net)
;-     If you use my code, please share your creations with me
;-     as I am always curious :)
;------------------------------------------------------------------------

.DEFINE NP		1
.DEFINE C4		2
.DEFINE SA1		3
.DEFINE SDD1		4
.DEFINE SPC7110		5
.DEFINE BS24		6
.DEFINE EXHIROM		7
.DEFINE GNEXT_UNITMAP	8

.DEFINE B_ROM_CHIP	$0D
.DEFINE B_ROM_SIZE	$0E
.DEFINE B_CARD_TYPE	$0F
.DEFINE W_LINE		$40
.DEFINE L_S2_ADDR	$54
.DEFINE L_D_ADDR	$57
.DEFINE L_S_ADDR	$5A
.DEFINE B_END_BANK	$5F
.DEFINE W_PRINT_BIN_C	$60
.DEFINE B_TEMP1		$ED
.DEFINE W_TEMP1		$EE

;---------------------------------------------------------------------------------
; LoRom
;---------------------------------------------------------------------------------

.MEMORYMAP             ; Tell WLA that the SNES has ROM at locations 8000-$FFFF
SLOTSIZE $8000         ; in every bank and that this area is $8000 bytes in size.
DEFAULTSLOT 0          ; There is only a single slot in SNES, other consoles
SLOT 0 $8000           ;	may have more slots per bank.
.ENDME

.ROMBANKSIZE $8000     ; Every ROM bank is 32 KBytes in size, also necessary.
.ROMBANKS 16           ; 4Mbits -- Tells WLA that you want to use 16 ROM banks.
.EMPTYFILL $FF
;---------------------------------------------------------------------------------

.BANK 0 SLOT 0
.ORG 0
Main:
	sei
	clc
	xce

	JML $008007
	
	rep #$20
	lda #$0000
	tcd             ; set Direct Page REG $0000

	lda #$1FFF      ; set stack to $1FFF
	tcs
	
	sep #$20

	lda #$00
	pha
	plb			; set DBR $00
	
	lda #$01 ;Set CPU speed to 3.58MHz
	;lda #$00 ;Set CPU speed to 2.68MHz
	sta $420d

	lda #$01
	sta $4200 ;NMI disable

	lda #$8F
	sta $2100 ;turn screen off for now, set brightness to normal

	jsr ClearRegs
	
	stz $2106;Mosaic off

	lda #$00 ;BG1SC
	sta $2107

	lda #$01 ;BG12NBA 1000h
	sta $210B

	stz $210D ;BG0 H-Offset
	stz $210D ;
	stz $210E ;BG0 V-Offset
	stz $210E ;
	
	lda #$03
	sta $2121 ;set CG-RAM address
	lda #$FF  ; color white
	sta $2122
	sta $2122

	;load ankfont
	lda #$80
	sta $2115 ;Set VRAM word access
	rep #$10
	ldy #$1000
	sty $2116
	ldy #$0000
_font_loop:	
	lda.w ankfont, y

	sta $2118
	sta $2119
	
	iny
	cpy #ankfont_end - ankfont
	bne _font_loop
	
	lda #$00
	sta $2115 ;Set VRAM byte access mode

	ldy #$0020;upper & left text blank
	sty W_LINE
	sty $2116

	ldy #title_str
	lda #title_str_end - title_str
	jsr print_text

	lda #$40
	jsr text_enter

	;; copy code to $7E:8000
	ldy #$8000
	sty $4305 ; Set transfer byte count
	sty $4302 ; Set source addr
	sty $4300 ; Set transfer mode 0, dest $2180
	sty $2181 ; set $7E:8000
	stz $2183
	stz $4304  ; Set source bank
	lda #$01
	sta $420B ;Do DMA transfer channel 0

	jml $7E0000 + jmp_addr
	
jmp_addr:
	jsr onscreen
	
	;; init
	lda #$00
	sta L_S2_ADDR
	lda #$80
	sta L_S2_ADDR + 1
	lda #$7F
	sta L_S2_ADDR + 2 ; S2 address
	
	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A
	
	lda #$03+$0C ; CARD mode
	sta $2189

	;; clear type
	stz B_CARD_TYPE

_detect0:
	jsr np_detect
/*	
	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A

	lda #$03+$0C ; CARD mode
	sta $2189

	;; Disable UFO Regs
	lda #$5A
	sta $218B
	lda #$4F
	sta $218A

	lda #$C0
	sta L_D_ADDR
	lda #$FF
	sta L_D_ADDR + 1
	lda #$00
	sta L_D_ADDR + 2
	
	ldy #$0040
	sty W_PRINT_BIN_C
	ldy #$0000
	jsr dump_addr

	lda #$20
	jsr text_enter

	jmp stop
*/
	lda B_CARD_TYPE
	cmp #NP
	bne _detect1
	jsr wait_vblank
	ldy #np_detected_str
	lda #np_detected_str_end - np_detected_str
	jsr print_text
	lda #$40
	jsr text_enter
	jsr wait_joypad_A
	jsr np_dump
	jmp _finished

_detect1:
	jsr c4_detect
	lda B_CARD_TYPE
	cmp #C4
	bne _detect2
	jsr wait_vblank
	ldy #c4_detected_str
	lda #c4_detected_str_end - c4_detected_str
	jsr print_text
	lda #$40
	jsr text_enter
	jsr wait_joypad_A
	jsr c4_dump
	jmp _finished

_detect2:
	jsr sa1_detect
	lda B_CARD_TYPE
	cmp #SA1
	bne _detect3
	jsr wait_vblank
	ldy #sa1_detected_str
	lda #sa1_detected_str_end - sa1_detected_str
	jsr print_text
	lda #$40
	jsr text_enter
	jsr wait_joypad_A
	jsr sa1_dump
	jmp _finished

_detect3:
	jsr sd1_detect
	lda B_CARD_TYPE
	cmp #SDD1
	bne _detect4
	jsr wait_vblank
	ldy #sd1_detected_str
	lda #sd1_detected_str_end - sd1_detected_str
	jsr print_text
	lda #$40
	jsr text_enter
	jsr wait_joypad_A
	jsr sd1_dump
	jmp _finished

_detect4:
	jsr s71_detect
	lda B_CARD_TYPE
	cmp #SPC7110
	bne _detect5
	jsr wait_vblank
	ldy #s71_detected_str
	lda #s71_detected_str_end - s71_detected_str
	jsr print_text
	lda #$40
	jsr text_enter
	lda B_ROM_SIZE
	cmp #$0D
	beq _s72
	jsr wait_joypad_A
	bra _s71

_s72:	;; wait joypad
	ldy #press_AX_select_str
	lda #press_AX_select_str_end - press_AX_select_str
	jsr print_text

	lda #$40
	jsr text_enter

	;; wait AX button press
_J1:	lda $4212
	and #$C1   ; It needs H/V blank check on real hardware.
	cmp #$C0
	bne _J1
	lda $4218
	bit #$C0
	beq _J1
	bit #$80
	bne _s71
	jsr s72_dump
	bra _s71f
_s71:	jsr s71_dump
_s71f:	jmp _finished

_detect5:
	jsr b24_detect
	lda B_CARD_TYPE
	cmp #BS24
	bne _detect6
	jsr wait_vblank
	ldy #b24_detected_str
	lda #b24_detected_str_end - b24_detected_str
	jsr print_text
	lda #$40
	jsr text_enter
	jsr wait_joypad_A
	jsr b24_dump
	jmp _finished

_detect6:
	jsr eh_detect
	lda B_CARD_TYPE
	cmp #EXHIROM
	bne _detect7
	jsr wait_vblank
	ldy #eh_detected_str
	lda #eh_detected_str_end - eh_detected_str
	jsr print_text
	lda #$40
	jsr text_enter
	jsr wait_joypad_A
	jsr eh_dump
	jmp _finished

_detect7:
	jsr gn_detect
	lda B_CARD_TYPE
	cmp #GNEXT_UNITMAP
	bne _detect8
	jsr wait_vblank
	ldy #gn_detected_str
	lda #gn_detected_str_end - gn_detected_str
	jsr print_text
	lda #$40
	jsr text_enter
	jsr wait_joypad_A
	jsr gn_dump
	jmp _finished
	
_detect8:
	;; none
	jsr wait_vblank
	ldy #none_str
	lda #none_str_end - none_str
	jsr print_text
	jmp stop

_finished:
	;; finished
	jsr wait_vblank
	ldy #finished_str
	lda #finished_str_end - finished_str
	jsr print_text

	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A
/*
	jsr wait_joypad_R
	
	rep #$20
	lda $FFFC
	sta $7E0000 + jmla.l + 1
	sep #$20
jmla:	jml $000000
*/	
stop:	bra stop

np_detect:
	lda $802400
	cmp #$7D ; Fixed 7Dh before wakeup
	beq _np_wake
	cmp #$2A ; Fixed 2Ah after wakeup
	beq _np_waked
	jmp _np_detect_end

	;; wakeup sequence
_np_wake:
	lda #$09
	sta $802400
	lda $802400
	lda #$28
	sta $802401
	lda #$84
	sta $802401
	lda #$06
	sta $802400
	lda #$39
	sta $802400
_np_waked:
	lda #$04 ; HIROM:ALL  (map whole FLASH in HiROM mode)
	sta $802400
	
	; C0AAAAh/C05554h 2.0MByte flash chip
	LDA #$AA	;
	STA $C0AAAA	; Read/Reset
	LDA #$55	; 
	STA $C05554	; 
	LDA #$F0	; 
	STA $C0AAAA	; 

	LDA #$AA
	STA $C0AAAA
	LDA #$55
	STA $C05554
	LDA #$90
	STA $C0AAAA
	lda $C00000 ; Get Maker ID
	sta $00
	lda $C00002 ; Get Device ID
	sta $02
	lda $C00004 ; Get Sector Protect
	sta $04

	LDA #$AA	;
	STA $C0AAAA	; Read/Reset
	LDA #$55	; 
	STA $C05554	; 
	LDA #$F0	; 
	STA $C0AAAA	; 
	
	; E0AAAAh/E05554h 2.0MByte flash chip
	LDA #$AA	;
	STA $E0AAAA	; Read/Reset
	LDA #$55	; 
	STA $E05554	; 
	LDA #$F0	; 
	STA $E0AAAA	; 

	LDA #$AA
	STA $E0AAAA
	LDA #$55
	STA $E05554
	LDA #$90
	STA $E0AAAA
	lda $E00000 ; Get Maker ID
	sta $10
	lda $E00002 ; Get Device ID
	sta $12
	lda $E00004 ; Get Sector Protect
	sta $14

	LDA #$AA	;
	STA $E0AAAA	; Read/Reset
	LDA #$55	; 
	STA $E05554	; 
	LDA #$F0	; 
	STA $E0AAAA	; 
	
	lda $00
	cmp #$C2 ; Manufacturer ID "Macronix"
	bne _np_detect_end
	lda $10
	cmp #$C2 ; Manufacturer ID "Macronix"
	bne _np_detect_end
	lda #NP
	sta B_CARD_TYPE
_np_detect_end:
	rts

c4_detect:
	lda $80FFD6
	cmp #$F3
	bne _c4_detect_end
	lda #C4
	sta B_CARD_TYPE
_c4_detect_end:
	rts

sa1_detect:
	rep #$20
	lda $80FFD6
	cmp #$0C34
	beq _sa1_detected
	cmp #$0C35
	beq _sa1_detected
	sep #$20
	bra _sa1_detect_end
_sa1_detected:
	sep #$20
	lda #SA1
	sta B_CARD_TYPE
_sa1_detect_end:
	rts

sd1_detect:
	rep #$20
	lda $80FFD6
	sta B_ROM_CHIP
	cmp #$0C43
	beq _sd1_detected
	cmp #$0D45
	beq _sd1_detected
	sep #$20
	bra _sd1_detect_end
_sd1_detected:
	sep #$20
	lda #SDD1
	sta B_CARD_TYPE
_sd1_detect_end:
	rts

s71_detect:
	rep #$20
	lda $80FFD6
	sta B_ROM_CHIP
	cmp #$0DF9
	beq _s71_detected
	cmp #$0CF5
	beq _s71_detected
	cmp #$0BF5
	beq _s71_detected
	sep #$20
	bra _s71_detect_end
_s71_detected:
	sep #$20
	lda #SPC7110
	sta B_CARD_TYPE
_s71_detect_end:
	rts

b24_detect:
	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A

	lda #$03+$0C ; CARD mode
	sta $2189

	;; Disable UFO Regs
	lda #$5A
	sta $218B
	lda #$4F
	sta $218A

	lda #$C0
	sta L_S_ADDR
	lda #$FF
	sta L_S_ADDR + 1
	lda #$80
	sta L_S_ADDR + 2 ; S address

	phb
	phk
	plb
	
	ldy #$0000
_b24dl:	lda db96_cartname_str, y
	cmp [L_S_ADDR], y
	bne _b24_detect_end0
	iny
	cpy #$15
	bne _b24dl
	lda #BS24
	sta B_CARD_TYPE
	bra _b24_detect_end
_b24_detect_end0:

	lda #$C0
	sta L_S_ADDR
	lda #$FF
	sta L_S_ADDR + 1
	lda #$00
	sta L_S_ADDR + 2 ; S address

	ldy #$0000
_b24d1:	lda sn_cartname_str, y
	cmp [L_S_ADDR], y
	bne _b24_detect_end
	iny
	cpy #$15
	bne _b24d1
	lda #BS24
	sta B_CARD_TYPE
_b24_detect_end:
	plb

	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A

	lda #$03+$0C ; CARD mode
	sta $2189
	rts

gn_detect:
	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A

	lda #$03+$0C ; CARD mode
	sta $2189

	;; Disable UFO Regs
	lda #$5A
	sta $218B
	lda #$4F
	sta $218A

	lda #$C0
	sta L_S_ADDR
	lda #$FF
	sta L_S_ADDR + 1
	lda #$80
	sta L_S_ADDR + 2 ; S address

	phb
	phk
	plb
	
	ldy #$0000
_gndl:	lda gnext_cartname_str, y
	cmp [L_S_ADDR], y
	bne _gn_detect_end
	iny
	cpy #$15
	bne _gndl
	lda #GNEXT_UNITMAP
	sta B_CARD_TYPE
_gn_detect_end:
	plb

	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A

	lda #$03+$0C ; CARD mode
	sta $2189
	rts
	
eh_detect:
	rep #$20
	lda $80FFD6
	cmp #$0D02
	beq _eh_detected
	cmp #$0D55
	beq _eh_detected
	sep #$20
	bra _eh_detect_end
_eh_detected:
	sep #$20
	lda #EXHIROM
	sta B_CARD_TYPE
_eh_detect_end:
	rts

	
np_dump:
	ldy #ripping_str
	lda #ripping_str_end - ripping_str
	jsr print_text
	
	lda #$00
	sta L_S_ADDR
	lda #$00
	sta L_S_ADDR + 1
	lda #$C0
	sta L_S_ADDR + 2 ; S address

	lda #$00
	sta L_D_ADDR
	lda #$80
	sta L_D_ADDR + 1
	lda #$80
	sta L_D_ADDR + 2 ; D address

	lda #$00
	sta B_END_BANK
	
	jsr _copy_hirom
	
	;; OK!
	jsr wait_vblank
	ldy #ok_str
	lda #ok_str_end - ok_str
	jsr print_text
	
	lda #$80
	jsr text_enter

	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A

	lda #$02+$0C ; DRAM RX mode
	sta $2189

	jsr _copy_header

	lda #$20 ; set DRAM data size
	sta $3FC1

	;; "NP      " filename
	lda #'N'
	sta $3FD2
	lda #'P'
	sta $3FD3
	lda #' '
	sta $3FD4
	lda #' '
	sta $3FD5
	lda #' '
	sta $3FD6
	lda #' '
	sta $3FD7
	lda #' '
	sta $3FD8
	lda #' '
	sta $3FD9
	rts

c4_dump:
	ldy #ripping_str
	lda #ripping_str_end - ripping_str
	jsr print_text

	;; C4 register
	lda #$00
	sta $807F52
	
	lda #$00
	sta L_S_ADDR
	lda #$80
	sta L_S_ADDR + 1
	lda #$80
	sta L_S_ADDR + 2 ; S address

	lda #$00
	sta L_D_ADDR
	lda #$80
	sta L_D_ADDR + 1
	lda #$80
	sta L_D_ADDR + 2 ; D address

	lda #$C0
	sta B_END_BANK
	
	jsr _copy_lorom
	
	;; OK!
	jsr wait_vblank
	ldy #ok_str
	lda #ok_str_end - ok_str
	jsr print_text
	
	lda #$60
	jsr text_enter

	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A

	lda #$02+$0C ; DRAM RX mode
	sta $2189

	jsr _copy_header

	lda #$10 ; set DRAM data size
	sta $3FC1

	;; "C4      " filename
	lda #'C'
	sta $3FD2
	lda #'4'
	sta $3FD3
	lda #' '
	sta $3FD4
	lda #' '
	sta $3FD5
	lda #' '
	sta $3FD6
	lda #' '
	sta $3FD7
	lda #' '
	sta $3FD8
	lda #' '
	sta $3FD9
	rts

sa1_dump:
	ldy #ripping_str
	lda #ripping_str_end - ripping_str
	jsr print_text
/*
	;; MMC
	lda #$00
	sta $802220
	lda #$01
	sta $802221
	lda #$02
	sta $802222
	lda #$03
	sta $802223
*/	
	lda #$00
	sta L_S_ADDR
	lda #$80
	sta L_S_ADDR + 1
	lda #$00
	sta L_S_ADDR + 2 ; S address

	lda #$00
	sta L_D_ADDR
	lda #$80
	sta L_D_ADDR + 1
	lda #$80
	sta L_D_ADDR + 2 ; D address

	lda #$C0
	sta B_END_BANK
	
	jsr _copy_lorom

	lda #$00
	sta L_S_ADDR
	lda #$80
	sta L_S_ADDR + 1
	lda #$80
	sta L_S_ADDR + 2 ; S address

	lda #$00
	sta L_D_ADDR
	lda #$80
	sta L_D_ADDR + 1
	lda #$C0
	sta L_D_ADDR + 2 ; D address

	lda #$00
	sta B_END_BANK
	
	jsr _copy_lorom
	
	;; OK!
	jsr wait_vblank
	ldy #ok_str
	lda #ok_str_end - ok_str
	jsr print_text
	
	lda #$80
	jsr text_enter

	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A

	lda #$02+$0C ; DRAM RX mode
	sta $2189

	jsr _copy_header

	lda #$20 ; set DRAM data size
	sta $3FC1

	;; "SA1_32M " filename
	lda #'S'
	sta $3FD2
	lda #'A'
	sta $3FD3
	lda #'1'
	sta $3FD4
	lda #'_'
	sta $3FD5
	lda #'3'
	sta $3FD6
	lda #'2'
	sta $3FD7
	lda #'M'
	sta $3FD8
	lda #' '
	sta $3FD9
	rts

sd1_dump:
	ldy #ripping_str
	lda #ripping_str_end - ripping_str
	jsr print_text
/*
	lda #$00
	sta $804800 ; sdd1_enable
	lda #$00
	sta $804801 ; xfer_enable

	lda #$00
	sta $804802 ; Unknown
	lda #$00
	sta $804803 ; Unknown
*/	
	;; MMC
	lda #$02
	sta $804804
	lda #$03
	sta $804805
	lda #$04
	sta $804806
	lda #$05
	sta $804807
/*
	lda #$FA
	sta $804804
	lda #$FB
	sta $804805
	lda #$FC
	sta $804806
	lda #$FD
	sta $804807
*/
	lda B_ROM_SIZE
	cmp #$0D
	beq _sd1_high
	
	lda #$00
	sta L_S_ADDR
	lda #$80
	sta L_S_ADDR + 1
	lda #$80
	sta L_S_ADDR + 2 ; S address

	lda #$00
	sta L_D_ADDR
	lda #$80
	sta L_D_ADDR + 1
	lda #$80
	sta L_D_ADDR + 2 ; D address

	lda #$C0
	sta B_END_BANK
	
	jsr _copy_lorom

_sd1_high:
	lda #$00
	sta L_S_ADDR
	lda #$00
	sta L_S_ADDR + 1
	lda #$C0
	sta L_S_ADDR + 2 ; S address

	lda #$00
	sta L_D_ADDR
	lda #$80
	sta L_D_ADDR + 1

	lda #$80
	sta L_D_ADDR + 2 ; D address
	lda B_ROM_SIZE
	cmp #$0D
	beq _sd1_skip0
	lda #$C0
	sta L_D_ADDR + 2 ; D address
_sd1_skip0:

	lda #$00
	sta B_END_BANK
	
	;jsr _copy_hirom2
	jsr _copy_hirom
	
	;; OK!
	jsr wait_vblank
	ldy #ok_str
	lda #ok_str_end - ok_str
	jsr print_text
	
	lda #$80
	jsr text_enter

	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A

	lda #$02+$0C ; DRAM RX mode
	sta $2189

	jsr _copy_header

	lda #$20 ; set DRAM data size
	sta $3FC1

	;; "S-DD1   " filename
	lda #'S'
	sta $3FD2
	lda #'-'
	sta $3FD3
	lda #'D'
	sta $3FD4
	lda #'D'
	sta $3FD5
	lda #'1'
	sta $3FD6
	lda #' '
	sta $3FD7
	lda #' '
	sta $3FD8
	lda #' '
	sta $3FD9
	rts

s71_dump:
	ldy #ripping_str
	lda #ripping_str_end - ripping_str
	jsr print_text
	
	;; MMC
	lda #$00
	sta $804831
	lda #$01
	sta $804832
	lda #$02
	sta $804833
	lda #$03
	sta $804834
	
	lda #$00
	sta L_S_ADDR
	lda #$00
	sta L_S_ADDR + 1
	lda #$C0
	sta L_S_ADDR + 2 ; S address

	lda #$00
	sta L_D_ADDR
	lda #$80
	sta L_D_ADDR + 1
	lda #$80
	sta L_D_ADDR + 2 ; D address

	lda #$00
	sta B_END_BANK
	lda B_ROM_SIZE
	cmp #$0D
	beq _s71_s0
	lda #$E0
	sta B_END_BANK
	lda B_ROM_SIZE
	cmp #$0C
	beq _s71_s0
	lda #$C0
	sta B_END_BANK
_s71_s0:	
	
	jsr _copy_hirom
	
	;; OK!
	jsr wait_vblank
	ldy #ok_str
	lda #ok_str_end - ok_str
	jsr print_text
	
	lda #$80
	jsr text_enter

	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A

	lda #$02+$0C ; DRAM RX mode
	sta $2189

	jsr _copy_header

	lda #$20 ; set DRAM data size
	sta $3FC1
	lda B_ROM_SIZE
	cmp #$0D
	beq _s71_s1
	lda #$18
	sta $3FC1
	lda B_ROM_SIZE
	cmp #$0C
	beq _s71_s1
	lda #$10
	sta $3FC1
_s71_s1:

	;; "S7110   " filename
	lda #'S'
	sta $3FD2
	lda #'7'
	sta $3FD3
	lda #'1'
	sta $3FD4
	lda #'1'
	sta $3FD5
	lda #'0'
	sta $3FD6

	lda B_ROM_SIZE
	cmp #$0D
	beq _s71_s2
	lda #' '
	sta $3FD7
	lda #' '
	sta $3FD8
	bra _s71_s3
_s71_s2:	
	lda #'_'
	sta $3FD7
	lda #'L'
	sta $3FD8
_s71_s3:
	lda #' '
	sta $3FD9
	rts

s72_dump:
	ldy #ripping_str
	lda #ripping_str_end - ripping_str
	jsr print_text
	
	;; MMC
	lda #$00
	sta $804831
	lda #$01
	sta $804832
	lda #$03
	sta $804833
	lda #$03
	sta $804834
	
	lda #$00
	sta L_S_ADDR
	lda #$00
	sta L_S_ADDR + 1
	lda #$F0
	sta L_S_ADDR + 2 ; S address

	lda #$00
	sta L_D_ADDR
	lda #$80
	sta L_D_ADDR + 1
	lda #$80
	sta L_D_ADDR + 2 ; D address

	lda #$A0
	sta B_END_BANK
	
	jsr _copy_hirom
	
	;; OK!
	jsr wait_vblank
	ldy #ok_str
	lda #ok_str_end - ok_str
	jsr print_text
	
	lda #$40
	jsr text_enter

	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A

	lda #$02+$0C ; DRAM RX mode
	sta $2189

	jsr _copy_header

	lda #$08 ; set DRAM data size
	sta $3FC1

	;; "S7110   " filename
	lda #'S'
	sta $3FD2
	lda #'7'
	sta $3FD3
	lda #'1'
	sta $3FD4
	lda #'1'
	sta $3FD5
	lda #'0'
	sta $3FD6
	lda #'_'
	sta $3FD7
	lda #'H'
	sta $3FD8
	lda #' '
	sta $3FD9
	rts

b24_dump:
	ldy #ripping_str
	lda #ripping_str_end - ripping_str
	jsr print_text
	
	lda #$00
	sta L_S_ADDR
	lda #$80
	sta L_S_ADDR + 1
	lda #$00
	sta L_S_ADDR + 2 ; S address

	lda #$00
	sta L_D_ADDR
	lda #$80
	sta L_D_ADDR + 1
	lda #$80
	sta L_D_ADDR + 2 ; D address

	lda #$C0
	sta B_END_BANK
	
	jsr _copy_lorom
	
	lda #$00
	sta L_S_ADDR
	lda #$80
	sta L_S_ADDR + 1
	lda #$80
	sta L_S_ADDR + 2 ; S address

	lda #$00
	sta L_D_ADDR
	lda #$80
	sta L_D_ADDR + 1
	lda #$C0
	sta L_D_ADDR + 2 ; D address

	lda #$E0
	sta B_END_BANK
	
	jsr _copy_lorom
	
	;; OK!
	jsr wait_vblank
	ldy #ok_str
	lda #ok_str_end - ok_str
	jsr print_text
	
	lda #$60
	jsr text_enter

	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A

	lda #$02+$0C ; DRAM RX mode
	sta $2189

	jsr _copy_header

	lda #$18 ; set DRAM data size
	sta $3FC1

	;; "BS24    " filename
	lda #'B'
	sta $3FD2
	lda #'S'
	sta $3FD3
	lda #'2'
	sta $3FD4
	lda #'4'
	sta $3FD5
	lda #' '
	sta $3FD6
	lda #' '
	sta $3FD7
	lda #' '
	sta $3FD8
	lda #' '
	sta $3FD9
	rts
	
eh_dump:
	ldy #ripping_str
	lda #ripping_str_end - ripping_str
	jsr print_text
	
	lda #$00
	sta L_S_ADDR
	lda #$00
	sta L_S_ADDR + 1
	lda #$C0
	sta L_S_ADDR + 2 ; S address

	lda #$00
	sta L_D_ADDR
	lda #$80
	sta L_D_ADDR + 1
	lda #$80
	sta L_D_ADDR + 2 ; D address

	lda #$00
	sta B_END_BANK
	
	jsr _copy_hirom
	
	;; OK!
	jsr wait_vblank
	ldy #ok_str
	lda #ok_str_end - ok_str
	jsr print_text
	
	lda #$80
	jsr text_enter

	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A

	lda #$02+$0C ; DRAM RX mode
	sta $2189

	jsr _copy_header

	lda #$20 ; set DRAM data size
	sta $3FC1

	;; "EXHIROM " filename
	lda #'E'
	sta $3FD2
	lda #'X'
	sta $3FD3
	lda #'H'
	sta $3FD4
	lda #'I'
	sta $3FD5
	lda #'R'
	sta $3FD6
	lda #'O'
	sta $3FD7
	lda #'M'
	sta $3FD8
	lda #' '
	sta $3FD9
	rts
	
gn_dump:
	ldy #ripping_str
	lda #ripping_str_end - ripping_str
	jsr print_text

	;; MMC
	lda #$04
	sta $802220
	lda #$05
	sta $802221
	lda #$06
	sta $802222
	lda #$07
	sta $802223
	
	lda #$00
	sta L_S_ADDR
	lda #$00
	sta L_S_ADDR + 1
	lda #$C0
	sta L_S_ADDR + 2 ; S address

	lda #$00
	sta L_D_ADDR
	lda #$80
	sta L_D_ADDR + 1
	lda #$80
	sta L_D_ADDR + 2 ; D address

	lda #$90
	sta B_END_BANK
	
	jsr _copy_hirom
	
	;; OK!
	jsr wait_vblank
	ldy #ok_str
	lda #ok_str_end - ok_str
	jsr print_text
	
	lda #$40
	jsr text_enter

	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A

	lda #$02+$0C ; DRAM RX mode
	sta $2189

	jsr _copy_header

	lda #$04 ; set DRAM data size
	sta $3FC1

	;; "UNITMAP " filename
	lda #'U'
	sta $3FD2
	lda #'N'
	sta $3FD3
	lda #'I'
	sta $3FD4
	lda #'T'
	sta $3FD5
	lda #'M'
	sta $3FD6
	lda #'A'
	sta $3FD7
	lda #'P'
	sta $3FD8
	lda #' '
	sta $3FD9
	rts


_copy_lorom:
_lol:	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A

	lda #$03+$0C ; CARD mode
	sta $2189

	;; Disable UFO Regs
	lda #$5A
	sta $218B
	lda #$4F
	sta $218A
	
	;; copy CARD to $7F:8000
	jsr _copy_s2

	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A
	
	lda #$00+$0C ; DRAM RW mode
	sta $2189

	ldy #$0000

_loll:	lda [L_S2_ADDR], y
	sta [L_D_ADDR], y
	iny
	cpy #$8000
	bne _loll

	lda L_S_ADDR + 2
	bit #$01
	beq _lolls
	jsr wait_char
_lolls:
	inc L_S_ADDR + 2
	inc L_D_ADDR + 2
	lda L_D_ADDR + 2
	cmp B_END_BANK
	bne _lol
	rts

_copy_hirom:
_hil:	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A

	lda #$03+$0C ; CARD mode
	sta $2189

	;; Disable UFO Regs
	lda #$5A
	sta $218B
	lda #$4F
	sta $218A
	
	;; copy CARD to $7F:8000
	jsr _copy_s2

	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A
	
	lda #$00+$0C ; DRAM RW mode
	sta $2189

	ldy #$0000

_hill:	lda [L_S2_ADDR], y
	sta [L_D_ADDR], y
	iny
	cpy #$8000
	bne _hill

	lda L_S_ADDR + 1
	clc
	adc #$80
	sta L_S_ADDR + 1
	cmp #$00
	bne _hills
	jsr wait_char
	inc L_S_ADDR + 2
_hills:	inc L_D_ADDR + 2
	lda L_D_ADDR + 2
	cmp B_END_BANK
	bne _hil
	rts

_copy_hirom2:
_h2l:	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A

	lda #$03+$0C ; CARD mode
	sta $2189

	;; Disable UFO Regs
	lda #$5A
	sta $218B
	lda #$4F
	sta $218A
	
	;; copy CARD to $7F:8000
	jsr _copy_s22

	;; Set UFO mode
	lda #$5A
	sta $218B
	lda #$00
	sta $218A
	
	lda #$00+$0C ; DRAM RW mode
	sta $2189

	ldy #$0000

_h2ll:	lda [L_S2_ADDR], y
	sta [L_D_ADDR], y
	iny
	cpy #$8000
	bne _h2ll

	lda L_S_ADDR + 1
	clc
	adc #$80
	sta L_S_ADDR + 1
	cmp #$00
	bne _h2lls
	jsr wait_char
	inc L_S_ADDR + 2
_h2lls:	inc L_D_ADDR + 2
	lda L_D_ADDR + 2
	cmp B_END_BANK
	bne _h2l
	rts

_copy_s2:
	ldy #$8000
	sty $4305 ; Set transfer byte count
	stz $4300 ; Set transfer mode 0, dest $2180
	lda #$80
	sta $4301
	ldy #$8000
	sty $2181 ; set $7F:8000
	lda #$01
	sta $2183
	ldy L_S_ADDR
	sty $4302 ; Set source addr
	lda L_S_ADDR + 2
	sta $4304  ; Set source bank
	lda #$01
	sta $420B ;Do DMA transfer channel 0
	rts

_copy_s22:
	ldy #$0000
_s22l:	lda [L_S_ADDR], y
	sta [L_S2_ADDR], y
	iny
	cpy #$8000
	bne _s22l
	rts
/*
_copy_s22:
	ldy #$0000
_s22l:	lda [L_S_ADDR], y ; verifySORead
	sta B_TEMP1
	lda [L_S_ADDR], y
	cmp B_TEMP1
	bne _s22l
	sta [L_S2_ADDR], y
	iny
	cpy #$8000
	bne _s22l
	rts
*/
_copy_header:
	ldx #$0000
_chl:	lda $80FFC0, x
	sta $3FA0, x
	inx
	cpx #$0020
	bne _chl
	rts

dump_addr:
_dal:	jsr wait_vblank
	jsr _print_bin
	lda #$20
	jsr text_enter
	cpy W_PRINT_BIN_C
	beq _dal_e
	bra _dal
_dal_e:	rts

_print_bin:
	lda L_D_ADDR + 2
	jsr _charconv_h
	sta $2118
	lda L_D_ADDR + 2
	jsr _charconv_l
	sta $2118
	lda #':'
	sta $2118

	rep #$20
	tya
	clc
	adc L_D_ADDR
	sta W_TEMP1
	sep #$20
	
	lda W_TEMP1 + 1
	jsr _charconv_h
	sta $2118
	lda W_TEMP1 + 1
	jsr _charconv_l
	sta $2118

	lda W_TEMP1
	jsr _charconv_h
	sta $2118
	lda W_TEMP1
	jsr _charconv_l
	sta $2118

	lda #' '
	sta $2118

_pbl:	lda [L_D_ADDR], y
	jsr _charconv_h
	sta $2118
	lda [L_D_ADDR], y
	jsr _charconv_l
	sta $2118
	lda #' '
	sta $2118

	iny
	tya
	bit #$07
	bne _pbl
	rts

_charconv:
	and #$0F
	cmp #$0A
	bcs _cv0
	clc
	adc #$30
	bra _cv1
_cv0:	clc
	adc #$37
_cv1:	rts
	
_charconv_h:
	lsr
	lsr
	lsr
	lsr
	jsr _charconv
	rts
	
_charconv_l:
	and #$0F
	jsr _charconv
	rts
	
onscreen:
	lda #$00 ;set BGMode 0
	sta $2105 ;BG 0,1,2,3 tile size 8x8, off Highest priority for BG3
	sta $2133
	lda #$01
	sta $212C
	lda #$0F
	sta $2100
	rts

wait_vblank:
	lda $4210
	bpl wait_vblank
	rts
	
wait_char:
_WL:	lda $4210
	bpl _WL
	lda #'.'
	sta $2118
	rts
	
print_text:
	;Copy Text data to VRAM
	sta $4305  ; Set transfer byte count
	stz $4306
	sty $4302  ; Set source addr
	rep #$10
	ldy #$1800 ; Set transfer mode 0, dest $2118
	sty $4300
	phk
	pla
	sta $4304  ; Set source bank
	lda #$01
	sta $420B ;Do DMA transfer channel 0
	rts

text_enter:
	rep #$20
	and #$00FF
	clc
	adc W_LINE
	and #$FFE0
	sta W_LINE
	sta $2116
	sep #$20
	rts

wait_joypad_A:
	;; wait joypad
	ldy #press_A_str
	lda #press_A_str_end - press_A_str
	jsr print_text

	lda #$40
	jsr text_enter

	;; wait A button press
_J0:	lda $4212
	and #$C1   ; It needs H/V blank check on real hardware.
	cmp #$C0
	bne _J0
	lda $4218
	bit #$80
	beq _J0
	rts

wait_joypad_R:
	;; wait R button press
_J2:	lda $4212
	and #$C1   ; It needs H/V blank check on real hardware.
	cmp #$C0
	bne _J2
	lda $4218
	bit #$10
	beq _J2
	rts
	
ClearRegs:
	;set WRAM address
	;clr WRAM 2000h - 1FFFFh
	stz $2181 ;WRAM address low
	lda #$20
	sta $2182 ;WRAM address middle
	stz $2183 ;WRAM address high

	;set VRAM address
	lda #$80
	sta $2115 ;Set VRAM port to word access
	stz $2116 ;VRAM read/write address (low)
	stz $2117 ;VRAM read/write address (high)

	;set OAM address
	stz $2102 ;Sprite write address (low)
	stz $2103 ;Sprite register write address (high), sprite priority rotation bit.

	;set CG-RAM address
	stz $2121

	phk
	pla
	sta $4304 ;Set source bank WRAM
	sta $4314 ;Set source bank VRAM
	sta $4324 ;Set source bank OAM
	sta $4334 ;Set source bank CG-RAM
	
	rep #$10
	ldy #$8008 ;Set transfer mode 0, dest $2180, fixed address source for WRAM clr.
	sty $4300
	ldy #$1809 ;Set transfer mode 1(dest word mode), dest $2118, fixed address source for VRAM clr.
	sty $4310
	ldy #$0408 ;Set transfer mode 0, dest $2104, fixed address source for OAM clr.
	sty $4320
	ldy #$2208 ;Set transfer mode 0, dest $2122, fixed address source for CG-RAM clr.
	sty $4330
	
	ldy #zero
	sty $4302 ;Set source addr WRAM
	sty $4312 ;Set source addr VRAM
	sty $4322 ;Set source addr OAM
	sty $4332 ;Set source addr CG-RAM
	
	ldy #$e000 ;Set transfer byte count WRAM
	sty $4305
	ldy #$0000 ;Set transfer byte count VRAM
	sty $4315
	ldy #$0220 ;Set transfer byte count OAM
	sty $4325
	ldy #$0200 ;Set transfer byte count CG-RAM
	sty $4335
	
	lda #$0F
	sta $420B ;Do DMA transfer channel 0 1 2 3

	ldy #$0000 ;Set transfer byte count WRAM
	sty $4305

	lda #$01
	sta $420B ;Do DMA transfer channel 0

	;clr WRAM address
	stz $2181 ;WRAM address low
	stz $2182 ;WRAM address middle
	stz $2183 ;WRAM address high

	;clr VRAM address
	stz $2116 ;VRAM read/write address (low)
	stz $2117 ;VRAM read/write address (high)

	;clr OAM address
	stz $2102 ;Sprite write address (low)
	stz $2103 ;Sprite register write address (high), sprite priority rotation bit.

	;clr CG-RAM address
	stz $2121

	stz $2123 ;Window 1 and 2 enable for backgrounds 1 and 2
	stz $2124 ;Window 1 and 2 enable for backgrounds 3 and 4
	stz $2125 ;Window 1 and 2 enable for objects and colour window
	stz $2126 ;Window 1 left position
	stz $2127 ;Window 1 right position
	stz $2128 ;Window 2 left position
	stz $2129 ;Window 2 right position
	stz $212A ;Windows 1 & 2 overlap logic for backgrounds 1 - 4
	stz $212B ;Windows 1 & 2 overlap logic for objects and colour window
	stz $212C ;Main screen designation (backgrounds 1 - 4 and objects)
	stz $212D ;Sub-screen designation (backgrounds 1 - 4 and objects)
	stz $212E ;Window mask designation for main screen ?
	stz $212F ;Window mask designation for sub-screen ?
	stz $2130 ;Fixed colour addition or screen addition
	stz $2131 ;Colour addition or subtraction select
	stz $2132 ;Colour data for fixed colour addition/subtraction

	rts

NMIHandler:
	rti

IRQHandler:
	rti
	
EmptyHandler:
	rti

title_str:
.DB "UFO EX DUMPER"
title_str_end:

np_detected_str:
.DB "NINTENDO POWER is detected."
np_detected_str_end:

c4_detected_str:
.DB "CAPCOM C4 is detected."
c4_detected_str_end:

sa1_detected_str:
.DB "SA1 32Mbit is detected."
sa1_detected_str_end:

sd1_detected_str:
.DB "S-DD1 is detected."
sd1_detected_str_end:

s71_detected_str:
.DB "SPC7110 is detected."
s71_detected_str_end:

b24_detected_str:
.DB "BS 24M is detected."
b24_detected_str_end:

eh_detected_str:
.DB "ExHiROM is detected."
eh_detected_str_end:

gn_detected_str:
.DB "SD Gundam GNEXT is detected."
gn_detected_str_end:

db96_cartname_str:
.DB "DERBY STALLION 96    "
db96_cartname_str_end:

sn_cartname_str:
.DB "SOUND NOVEL-TCOOL    "
sn_cartname_str_end:

gnext_cartname_str:
.DB "SFC SDGUNDAMGNEXT    "
gnext_cartname_str_end:

none_str:
.DB "Cartridge is none."
none_str_end:

ripping_str:
.DB "Ripping"
ripping_str_end:

press_A_str:
.DB "Press A button to proceed"
press_A_str_end:

press_AX_select_str:
.DB "Press A low 32M, X high 8M"
press_AX_select_str_end:

finished_str:
.DB "Finished, Enter to Reset."
;.DB "Finished, Press R to Reset."
finished_str_end:
	
ok_str:
.DB "OK!"
ok_str_end:
	
ankfont:
.INCBIN "ankfont.dat"
ankfont_end:

zero:
.DB $00, $00

; === Cartridge Header - part 1 - =====================
.ORG    $7FB0
.DB     $00, $00                ; New Licensee Code ( 01 == Nintendo )
.DB     $00, $00, $00, $00      ; ID
.DB     $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
.ORG    $7FC0
.DB     "UFO EX DUMPER        " ; Title (can't be more than 21 bytes, and should probably be a full 21 bytes)
;       "0123456789ABCDEF01234" ; cart name length
.ORG    $7FD5
.DB     $30                     ; Memory Mode   ( $20 = Slow LoRom, $21 = Slow HiRom $30 = Fast LoRom, $31 = Fast HiRom )

; === Cartridge Header - part 2 - =====================
.ORG    $7FD6
.DB     $00                   ; Contents ( $00 = ROM only, $01 = ROM and RAM, $02 = ROM and Save RAM)
.DB     $0C                   ; ROM Size   ( $08 = 2 Mbit, $09 = 4 Mbit, $0A = 8Mbit, $0B = 16Mbit ... etc )
.DB     $00                   ; SRAM Size ( $00 = 0 bits, $01 = 16 kbits, $02 = 32 kbits, $03 = 64 kbits )
.DB     $00                   ; Country ( $01 = USA, $00 = Jap )
.DB     $00                   ; Licensee Code
.DB     $00                   ; Version
.DW    $FFFF                  ; Checksum Complement  (not calculated ... but who cares?)
.DW    $0000                  ; Checksum

; === Interrupt Vector Table ====================
.ORG    $7FE4                 ; === Native Mode ===
.DW     EmptyHandler          ; COP
.DW     EmptyHandler          ; BRK
.DW     EmptyHandler          ; ABORT
.DW     NMIHandler            ; NMI
.DW     $0000                 ; (Unused)
.DW     IRQHandler            ; IRQ

.ORG    $7FF4                 ; === Emulation Mode ===
.DW     EmptyHandler          ; COP
.DW     $0000                 ; (Unused)
.DW     EmptyHandler          ; ABORT
.DW     NMIHandler            ; NMI
.DW     Main                  ; RESET
.DW     IRQHandler            ; IRQ/BRK

; ============================================
